searchData={"items":[{"type":"module","title":"lhttpc","doc":"Main interface to the lightweight http client. See request/4 , request/5 and request/6 functions.","ref":"lhttpc.html"},{"type":"function","title":"lhttpc.add_pool/1","doc":"Add a new named httpc_manager pool to the supervisor tree","ref":"lhttpc.html#add_pool/1"},{"type":"function","title":"lhttpc.add_pool/2","doc":"Add a new httpc_manager to the supervisor tree","ref":"lhttpc.html#add_pool/2"},{"type":"function","title":"lhttpc.add_pool/3","doc":"Add a new httpc_manager to the supervisor tree","ref":"lhttpc.html#add_pool/3"},{"type":"function","title":"lhttpc.delete_pool/1","doc":"Delete a pool","ref":"lhttpc.html#delete_pool/1"},{"type":"function","title":"lhttpc.get_body_part/1","doc":"Reads a body part from an ongoing response when {partial_download, PartialDownloadOptions} is used. The default timeout, infinity will be used. Would be the same as calling get_body_part(HTTPClient, infinity) .","ref":"lhttpc.html#get_body_part/1"},{"type":"function","title":"lhttpc.get_body_part/2","doc":"Reads a body part from an ongoing response when {partial_download, PartialDownloadOptions} is used. Timeout is the timeout for reading the next body part in milliseconds. http_eob marks the end of the body. If there were Trailers in the response those are returned with http_eob as well. If it evers returns an error, no further calls to this function should be done.","ref":"lhttpc.html#get_body_part/2"},{"type":"function","title":"lhttpc.request/4","doc":"Sends a request without a body. Would be the same as calling request/5 with an empty body, request(URL, Method, Hdrs, [], Timeout) or request(URL, Method, Hdrs, &lt;&lt;&gt;&gt;, Timeout) . See also: request/9 .","ref":"lhttpc.html#request/4"},{"type":"function","title":"lhttpc.request/5","doc":"Sends a request with a body. Would be the same as calling request/6 with no options, request(URL, Method, Hdrs, Body, Timeout, []) . See also: request/9 .","ref":"lhttpc.html#request/5"},{"type":"function","title":"lhttpc.request/6","doc":"Sends a request with a body. Would be the same as calling # lhttpc_url { host = Host , port = Port , path = Path , is_ssl = Ssl } = lhttpc_lib : parse_url ( URL ) , request ( Host , Port , Path , Ssl , Method , Hdrs , Body , Timeout , Options ) . URL is expected to be a valid URL: scheme://host[:port][/path] . See also: request/9 .","ref":"lhttpc.html#request/6"},{"type":"function","title":"lhttpc.request/9","doc":"Sends a request with a body. Instead of building and parsing URLs the target server is specified with a host, port, weither SSL should be used or not and a path on the server. For instance, if you want to request http://example.com/foobar you would use the following: Host = &quot;example.com&quot; Port = 80 Ssl = false Path = &quot;/foobar&quot; Path must begin with a forward slash / . Method is either a string, stating the HTTP method exactly as in the protocol, i.e: &quot;POST&quot; or &quot;GET&quot; . It could also be an atom, which is then coverted to an uppercase (if it isn't already) string. Hdrs is a list of headers to send. Mandatory headers such as Host , Content-Length or Transfer-Encoding (for some requests) are added automatically. Body is the entity to send in the request. Please don't include entity bodies where there shouldn't be any (such as for GET ). Timeout is the timeout for the request in milliseconds. Options is a list of options. Options: {connect_timeout, Milliseconds} specifies how many milliseconds the client can spend trying to establish a connection to the server. This doesn't affect the overall request timeout. However, if it's longer than the overall timeout it will be ignored. Also note that the TCP layer my choose to give up earlier than the connect timeout, in which case the client will also give up. The default value is infinity, which means that it will either give up when the TCP stack gives up, or when the overall request timeout is reached. {connect_options, Options} specifies options to pass to the socket at connect time. This makes it possible to specify both SSL options and regular socket options, such as which IP/Port to connect from etc. Some options must not be included here, namely the mode, binary or list , {active, boolean()} , {active, once} or {packet, Packet} . These options would confuse the client if they are included. Please note that these options will only have an effect on *new* connections, and it isn't possible for different requests to the same host uses different options unless the connection is closed between the requests. Using HTTP/1.0 or including the &quot;Connection: close&quot; header would make the client close the connection after the first response is received. {send_retry, N} specifies how many times the client should retry sending a request if the connection is closed after the data has been sent. The default value is 1 . If {partial_upload, WindowSize} (see below) is specified, the client cannot retry after the first part of the body has been sent since it doesn't keep the whole entitity body in memory. {partial_upload, WindowSize} means that the request entity body will be supplied in parts to the client by the calling process. The WindowSize specifies how many parts can be sent to the process controlling the socket before waiting for an acknowledgement. This is to create a kind of internal flow control if the network is slow and the client process is blocked by the TCP stack. Flow control is disabled if WindowSize is infinity . If WindowSize is an integer, it must be &gt;= 0. If partial upload is specified and no Content-Length is specified in Hdrs the client will use chunked transfer encoding to send the entity body. If a content length is specified, this must be the total size of the entity body. The call to request/6 will return {ok, UploadState} . The UploadState is supposed to be used as the first argument to the send_body_part/2 or send_body_part/3 functions to send body parts. Partial upload is intended to avoid keeping large request bodies in memory but can also be used when the complete size of the body isn't known when the request is started. {partial_download, PartialDownloadOptions} means that the response body will be supplied in parts by the client to the calling process. The partial download option {window_size, WindowSize} specifies how many part will be sent to the calling process before waiting for an acknowledgement. This is to create a kind of internal flow control if the calling process is slow to process the body part and the network and server are considerably faster. Flow control is disabled if WindowSize is infinity . If WindowSize is an integer it must be &gt;=0. The partial download option {part_size, PartSize} specifies the size the body parts should come in. Note however that if the body size is not determinable (e.g entity body is termintated by closing the socket) it will be delivered in pieces as it is read from the wire. There is no caching of the body parts until the amount reaches body size. If the body size is bounded (e.g Content-Length specified or Transfer-Encoding: chunked specified) it will be delivered in PartSize pieces. Note however that the last piece might be smaller than PartSize . Size bounded entity bodies are handled the same way as unbounded ones if PartSize is infinity . If PartSize is integer it must be &gt;= 0. If {partial_download, PartialDownloadOptions} is specified the ResponseBody will be a pid() unless the response has no body (for example in case of HEAD requests). In that case it will be be undefined . The functions get_body_part/1 and get_body_part/2 can be used to read body parts in the calling process. {proxy, ProxyUrl} if this option is specified, a proxy server is used as an intermediary for all communication with the destination server. The link to the proxy server is established with the HTTP CONNECT method (RFC2817). Example value: {proxy, &quot;http://john:doe@myproxy.com:3128&quot;} {proxy_ssl_options, SslOptions} this is a list of SSL options to use for the SSL session created after the proxy connection is established. For a list of all available options, please check OTP's ssl module manpage.","ref":"lhttpc.html#request/9"},{"type":"function","title":"lhttpc.send_body_part/2","doc":"Sends a body part to an ongoing request when {partial_upload, WindowSize} is used. The default timeout, infinity will be used. Notice that if WindowSize is infinity, this call will never block. Would be the same as calling send_body_part(UploadState, BodyPart, infinity) .","ref":"lhttpc.html#send_body_part/2"},{"type":"function","title":"lhttpc.send_body_part/3","doc":"Sends a body part to an ongoing request when {partial_upload, WindowSize} is used. Timeout is the timeout for the request in milliseconds. If the window size reaches 0 the call will block for at maximum Timeout milliseconds. If there is no acknowledgement received during that time the the request is cancelled and {error, timeout} is returned. As long as the window size is larger than 0 the function will return immediately after sending the body part to the request handling process. The BodyPart http_eob signals an end of the entity body, the request is considered sent and the response will be read from the socket. If there is no response within Timeout milliseconds, the request is canceled and {error, timeout} is returned.","ref":"lhttpc.html#send_body_part/3"},{"type":"function","title":"lhttpc.send_trailers/2","doc":"Sends trailers to an ongoing request when {partial_upload, WindowSize} is used and no Content-Length was specified. The default timout infinity will be used. Plase note that after this the request is considered complete and the response will be read from the socket. Would be the same as calling send_trailers(UploadState, BodyPart, infinity) .","ref":"lhttpc.html#send_trailers/2"},{"type":"function","title":"lhttpc.send_trailers/3","doc":"Sends trailers to an ongoing request when {partial_upload, WindowSize} is used and no Content-Length was specified. Timeout is the timeout for sending the trailers and reading the response in milliseconds. Sending trailers also signals the end of the entity body, which means that no more body parts, or trailers can be sent and the response to the request will be read from the socket. If no response is received within Timeout milliseconds the request is canceled and {error, timeout} is returned.","ref":"lhttpc.html#send_trailers/3"},{"type":"function","title":"lhttpc.start/0","doc":"Start the application. This is a helper function that will call application:start(lhttpc) to allow the library to be started using the -s flag. For instance: $ erl -s crypto -s ssl -s lhttpc For more info on possible return values the application module.","ref":"lhttpc.html#start/0"},{"type":"function","title":"lhttpc.start/2","doc":null,"ref":"lhttpc.html#start/2"},{"type":"function","title":"lhttpc.stop/0","doc":"Stops the application. This is a helper function that will call application:stop(lhttpc) . For more info on possible return values the application module.","ref":"lhttpc.html#stop/0"},{"type":"function","title":"lhttpc.stop/1","doc":null,"ref":"lhttpc.html#stop/1"},{"type":"type","title":"lhttpc.body/0","doc":null,"ref":"lhttpc.html#t:body/0"},{"type":"type","title":"lhttpc.bodypart/0","doc":null,"ref":"lhttpc.html#t:bodypart/0"},{"type":"type","title":"lhttpc.destination/0","doc":null,"ref":"lhttpc.html#t:destination/0"},{"type":"type","title":"lhttpc.header/0","doc":null,"ref":"lhttpc.html#t:header/0"},{"type":"type","title":"lhttpc.headers/0","doc":null,"ref":"lhttpc.html#t:headers/0"},{"type":"type","title":"lhttpc.host/0","doc":null,"ref":"lhttpc.html#t:host/0"},{"type":"type","title":"lhttpc.http_status/0","doc":null,"ref":"lhttpc.html#t:http_status/0"},{"type":"type","title":"lhttpc.method/0","doc":null,"ref":"lhttpc.html#t:method/0"},{"type":"type","title":"lhttpc.option/0","doc":null,"ref":"lhttpc.html#t:option/0"},{"type":"type","title":"lhttpc.options/0","doc":null,"ref":"lhttpc.html#t:options/0"},{"type":"type","title":"lhttpc.partial_download_option/0","doc":null,"ref":"lhttpc.html#t:partial_download_option/0"},{"type":"type","title":"lhttpc.pool_id/0","doc":null,"ref":"lhttpc.html#t:pool_id/0"},{"type":"type","title":"lhttpc.poolsize/0","doc":null,"ref":"lhttpc.html#t:poolsize/0"},{"type":"type","title":"lhttpc.port_num/0","doc":null,"ref":"lhttpc.html#t:port_num/0"},{"type":"type","title":"lhttpc.pos_timeout/0","doc":null,"ref":"lhttpc.html#t:pos_timeout/0"},{"type":"type","title":"lhttpc.result/0","doc":null,"ref":"lhttpc.html#t:result/0"},{"type":"type","title":"lhttpc.socket/0","doc":null,"ref":"lhttpc.html#t:socket/0"},{"type":"type","title":"lhttpc.socket_options/0","doc":null,"ref":"lhttpc.html#t:socket_options/0"},{"type":"type","title":"lhttpc.upload_state/0","doc":null,"ref":"lhttpc.html#t:upload_state/0"},{"type":"type","title":"lhttpc.window_size/0","doc":null,"ref":"lhttpc.html#t:window_size/0"},{"type":"module","title":"lhttpc_manager","doc":"Connection manager for the HTTP client. This gen_server is responsible for keeping track of persistent connections to HTTP servers. The only interesting API is connection_count/0 and connection_count/1 . The gen_server is supposed to be started by a supervisor, which is normally lhttpc_sup .","ref":"lhttpc_manager.html"},{"type":"function","title":"lhttpc_manager.client_count/1","doc":"Returns the total number of active clients maintained by the specified lhttpc pool (manager).","ref":"lhttpc_manager.html#client_count/1"},{"type":"function","title":"lhttpc_manager.client_done/5","doc":"A client has finished one request and returns the socket to the pool, which can be new or not.","ref":"lhttpc_manager.html#client_done/5"},{"type":"function","title":"lhttpc_manager.code_change/3","doc":null,"ref":"lhttpc_manager.html#code_change/3"},{"type":"function","title":"lhttpc_manager.connection_count/1","doc":"Returns the total number of active connections maintained by the specified lhttpc pool (manager).","ref":"lhttpc_manager.html#connection_count/1"},{"type":"function","title":"lhttpc_manager.connection_count/2","doc":"Returns the number of active connections to the specific Destination maintained by the httpc manager.","ref":"lhttpc_manager.html#connection_count/2"},{"type":"function","title":"lhttpc_manager.dump_settings/1","doc":"Returns the current settings in state for the specified lhttpc pool (manager).","ref":"lhttpc_manager.html#dump_settings/1"},{"type":"function","title":"lhttpc_manager.ensure_call/6","doc":"If call contains pool_ensure option, dynamically create the pool with configured parameters. Checks the pool for a socket connected to the destination and returns it if it exists, 'undefined' otherwise.","ref":"lhttpc_manager.html#ensure_call/6"},{"type":"function","title":"lhttpc_manager.handle_call/3","doc":null,"ref":"lhttpc_manager.html#handle_call/3"},{"type":"function","title":"lhttpc_manager.handle_cast/2","doc":null,"ref":"lhttpc_manager.html#handle_cast/2"},{"type":"function","title":"lhttpc_manager.handle_info/2","doc":null,"ref":"lhttpc_manager.html#handle_info/2"},{"type":"function","title":"lhttpc_manager.init/1","doc":null,"ref":"lhttpc_manager.html#init/1"},{"type":"function","title":"lhttpc_manager.list_pools/0","doc":"Lists all the pools already started.","ref":"lhttpc_manager.html#list_pools/0"},{"type":"function","title":"lhttpc_manager.set_max_pool_size/2","doc":"Sets the maximum pool size for the specified pool.","ref":"lhttpc_manager.html#set_max_pool_size/2"},{"type":"function","title":"lhttpc_manager.start_link/0","doc":"Starts and link to the gen server. This is normally called by a supervisor.","ref":"lhttpc_manager.html#start_link/0"},{"type":"function","title":"lhttpc_manager.start_link/1","doc":"Starts and link to the gen server (with options). This is normally called by a supervisor.","ref":"lhttpc_manager.html#start_link/1"},{"type":"function","title":"lhttpc_manager.terminate/2","doc":null,"ref":"lhttpc_manager.html#terminate/2"},{"type":"function","title":"lhttpc_manager.update_connection_timeout/2","doc":"Updates the timeout for persistent connections. This will only affect future sockets handed to the manager. The sockets already managed will keep their timers.","ref":"lhttpc_manager.html#update_connection_timeout/2"},{"type":"type","title":"lhttpc_manager.state/0","doc":null,"ref":"lhttpc_manager.html#t:state/0"},{"type":"module","title":"lhttpc_sup","doc":null,"ref":"lhttpc_sup.html"},{"type":"function","title":"lhttpc_sup.init/1","doc":null,"ref":"lhttpc_sup.html#init/1"},{"type":"function","title":"lhttpc_sup.start_link/0","doc":"Starts and links to the supervisor. This is normally called from an application behaviour or from another supervisor.","ref":"lhttpc_sup.html#start_link/0"},{"type":"extras","title":"Overview","doc":"# lhttpc [![GitHub Actions CI][ci-img]][ci]\n\n[ci]: https://github.com/miniclip/lhttpc\n[ci-img]: https://github.com/miniclip/lhttpc/workflows/build/badge.svg\n\n`lhttpc` is a **lightweight** HTTP client.","ref":"readme.html"},{"type":"extras","title":"Usage - Overview","doc":"```erlang\nURL = \"https://www.google.com\",\nMethod = get,\nHdrs = [],\nTimeout = 5000, % in milliseconds\n\nlhttpc:request(URL, Method, Hdrs, Timeout).\n```","ref":"readme.html#usage"},{"type":"extras","title":"Migration guide","doc":"# Migration guide\n\nWhenever there's an interface breaking change (a change in the project's major version),\nrequired migration instructions will be detailed in this file.","ref":"migration.html"},{"type":"extras","title":"From [3.x] to [4.x] - Migration guide","doc":"#","ref":"migration.html#from-3-x-to-4-x"},{"type":"extras","title":"Update - Migration guide","doc":"- your code to depend on types from `lhttpc:` and `lhttpc_client:` and not (imported)\n`lhttpc_types.hrl` (a simple `dialyzer` procedure should put into evidence what is\nmis-specified)\n- your code to not depend on `lhttpc.hrl`'s `lhttpc_url` record:\n  - if you're \"building\" the record, you can use\n`lhttpc_client:new_url(Host, Port, Path, IsSSL, User, Password)` where you were once\nusing\n`#lhttpc_url{ host = Host,\n              port = Port,\n              path = Path,\n              is_ssl = IsSSL,\n              user = User,\n              password = Password }`\n(`lhttpc_client:new_url/4` also available, for convenience)\n- your code to access the `lhttpc_url` record content via new accessor functions\n`lhttpc_client:url(LhttpcURL, FieldName)`\n\n#","ref":"migration.html#update"},{"type":"extras","title":"Remove - Migration guide","doc":"- your code's import of `lhttpc_types.hrl`\n- your code's import of `lhttpc.hrl`","ref":"migration.html#remove"},{"type":"extras","title":"From [2.x] to [3.x] - Migration guide","doc":"#","ref":"migration.html#from-2-x-to-3-x"},{"type":"extras","title":"Update - Migration guide","doc":"- calls to lhttpc:request/{4,5,6,9} requesting HTTPS URLs which you **do** need to\nkeep insecure, and only if you need to do so, by explicitly using the new\n`verify_ssl_cert` option:\n\n```erlang\n% before:\nlhttpc:request(\"https://self-signed.badssl.com\", \"GET\", [], <<>>, 5000).\n\n% after:\nlhttpc:request(\"https://self-signed.badssl.com\", \"GET\", [], <<>>, 5000,\n               [{verify_ssl_cert, false}]).\n```\n\n#","ref":"migration.html#update"},{"type":"extras","title":"Other info - Migration guide","doc":"- new dependencies:\n  - `certifi` (version 2.3.1)\n  - `ssl_verify_fun` (version 1.1.4)","ref":"migration.html#other-info"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/)\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n## [4.3.2] - 2024-03-11\n\n#","ref":"changelog.html"},{"type":"extras","title":"Changed - Changelog","doc":"- [dep.] `tls_certificate_check` from 1.9.0 to 1.21.0 [Dinis Rosário]\n\n## [4.3.1] - 2022-04-19\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Added - Changelog","doc":"- `rebar3_ex_doc` + `make ex_doc-dry` [Paulo Oliveira]\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- `edoc`-based doc. to `ex_doc`-based doc. [Paulo Oliveira]\n\n## [4.3.0] - 2021-09-16\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Changed - Changelog","doc":"- TLS certificate validation to prepare for\n[DST Root CA X3 expiration](https://blog.voltone.net/post/30) [Guilherme Andrade]\n- [dep.] `tls_certificate_check` from 1.7.0 to 1.9.0 [Guilherme Andrade]\n\n## [4.2.0] - 2021-07-16\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Added - Changelog","doc":"- `rebar3_hank` [Paulo Oliveira]\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- CI container approach to `setup-beam` with cache [Paulo Oliveira]\n- CA bundles, to base them on the latest Mozilla Included CA Certificate List [Guilherme Andrade]\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Removed - Changelog","doc":"- compatibility with OTP 21\n\n## [4.1.2] - 2021-03-15\n\n#","ref":"changelog.html#removed"},{"type":"extras","title":"Changed - Changelog","doc":"- [dep.] `tls_certificate_check` from 1.1.1 to 1.2.0 [Paulo Oliveira]\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- `rebar3` + `certifi` (now indirectly removed) compilation issues [Paulo Oliveira]\n\n## [4.1.1] - 2021-03-04\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Removed - Changelog","doc":"- unused dep `parse_trans` [Paulo Oliveira]\n\n## [4.1.0] - 2021-03-04\n\n#","ref":"changelog.html#removed"},{"type":"extras","title":"Changed - Changelog","doc":"- CI from 23.1 to 23.2 [Paulo Oliveira]\n- `rebar.config` to a fresher look-and-feel [Paulo Oliveira]\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Removed - Changelog","doc":"- all mentions of `@spec` [Paulo Oliveira]\n- `test/simple_load.erl` [Paulo Oliveira]\n\n## [4.0.0] - 2020-12-10\n\n#","ref":"changelog.html#removed"},{"type":"extras","title":"Added - Changelog","doc":"- all types that are exposed via API functions to their respective module's\n`export_type` sections [Paulo Oliveira]\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Removed - Changelog","doc":"- lhttpc_types.hrl [Paulo Oliveira]\n- lhttpc.hrl [Paulo Oliveira]\n- defined types that are unused internally (and not exported) [Paulo Oliveira]\n\n## [3.3.0] - 2020-05-22\n\n#","ref":"changelog.html#removed"},{"type":"extras","title":"Added - Changelog","doc":"- compatibility with OTP 23\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- Travis constraints: updated version as per our current reality; added `make check`\n- minimum supported version to 19.3\n- README.md: removed outdated info; added test-related info\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- some broken tests\n\n## [3.2.0] - 2020-04-30\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Changed - Changelog","doc":"- source of dependencies to Hex, for quicker builds\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Removed - Changelog","doc":"- support for OTP 17\n- support for OTP 18\n- support for rebar2\n\n## [3.1.0] - 2020-03-12\n\n#","ref":"changelog.html#removed"},{"type":"extras","title":"Added - Changelog","doc":"- exported types lhttpc:result/0 and lhttpc:headers/0\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- CA bundles, to base them on the latest Mozilla Included CA Certificate List\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- OTP 21 dialyzer warnings\n\n## [3.0.7] - 2019-09-25\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- unwarranted throwing of exception(s) to consumer during racy pool creation\n\n## [3.0.6] - 2019-09-24\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- warning on rebar3 over ssl_verify_fun's missing .app description\n\n## [3.0.5] - 2019-02-01\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- potential compilation issues when importing lib. as a dependency on OTP 21\n\n## [3.0.4] - 2019-01-23\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- bad specification of returned error reasons on :request/{4,5,6,9}\n\n## [3.0.3] - 2019-01-18\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- dialyzer warnings\n\n## [3.0.2] - 2018-09-13\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- OTP 21 compile-time warnings\n\n## [3.0.1] - 2018-08-07\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- rebar2 support\n\n## [3.0.0] - 2018-08-07\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- missing boot dependencies\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- application was rebar3ified while still being usable as a rebar2 dependency\n- application version is now determined from git\n- HTTPS requests are now secure by default\n\n#","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- unintelligibility of which test cases failed (main suite)\n- low test coverage due to broken test cases that prevented others from running\n\n#","ref":"changelog.html#fixed"},{"type":"extras","title":"OLD STYLE CHANGE LOG BELOW - Changelog","doc":"```text\nVersion ?:\n* Add support for connect_options\n    * Enables the user to pass socket options, for instance ip and port,\n      that will be used when connecting the socket\n    * Allows the user to specify SSL options during the connect phase\n* Add support for \"streaming\" of entities\n* Add start/0 and stop/0\n* Fix for unexpected messages after request has been completed\n    * When the client process is trapping exits (which some eunit versions seem\n      to be doing by default) there would be {'EXIT', Pid, normal} messages left\n      after completing requests which came from the lhttpc_client process.\n      These are now avoided.\n* Add rebar support (thanks to Benoit Chesneau)\n* Add support for HTTP basic auth (Filipe Manana)\n* Add support for IPv6 (Filipe Manana)\n* Several URL parsing fixes (Filipe Manana)\n* Add support for proxies via HTTP CONNECT method (Filipe Manana)\n* Add connection limit to the connection pool (Filipe Manana)\n* Add suport for using multiple connection pools - different requests can now\n  use different connection pools (Filipe Manana)\n\nVersion 1.2.5:\n* Fix for decoding chunked HTTP responses with extraneous whitespace\n  (thanks to Bob Ippolito)\n    * api.facebook.com includes extra whitespace in its chunked HTTP response\n      length, e.g. \"6  \\r\\n\" instead of \"6\\r\\n\".\n\nVersion 1.2.4:\n* Fix handling of HTTP response code 304 (patch by Ben Slavin)\n\nVersion 1.2.3:\n* Fix handling of unexpected 100 Continue response (patch by Magnus Henoch)\n\nVersion 1.2.2:\n* Fix Host header, add port number (reported by Benoit Chesneau)\n\nVersion 1.2.1:\n* Fix confusion of arguments in request/9 (introduced in 1.2.0)\n\nVersion 1.2.0:\n* Add support for options\n    * {connect_timeout, Milliseconds}: Aborts the connect phase after\n      Milliseconds\n    * {send_retry, N}: The client will retry sending the request N times\n      if the connection is closed\n* Add support for downloading chunked transfer encoding\n* More consistent error handling\n    * The client can either return {ok, Result} or {error, Reason}. Reason\n      (which wasn't very well defined before) can now be:\n        * connection_closed: The server closed the connection on us (N times\n          in case it happens just after sending the request)\n        * connect_timeout: If the TCP stack gives up or we hit the\n          connect_timeout option\n        * timeout: If the overall request timeout value is hit\n    * All other errors (socket, protocol etc. will result in a runtime error)\n* Better connection handling (issues #2 and #3 on bitbucket.org/etc/lhttpc)\n    * Now understands what to do with connections to servers < HTTP/1.1\n    * Now respects \"Connection: close\" in request headers, which means\n      clients can choose to not use persistent connections\n* RFC Compliance\n    * Fix reading of chunked encoding since section 3.6 claims that \"All\n      transfer-coding values are case-insensitive\"\n    * Support for responses that doesn't have an entity body (thanks to Steve\n      Ellis)\n        * No body for the HEAD and OPTIONS (unless indicated for the latter)\n          methods\n        * Don't try to read a body when receiving a 204 status\n\nVersion 1.1.2:\n* Fix minor error with {active, once} instead of {active, true} in manager\n* Remove socket and try to find another if the manager can't set controlling\n  process due to socket error\n* Improve test suite\n\nVersion 1.1.1:\n* Fix problem with empty lists in dicts when last socket is consumed\n* Improve test suite to include cover report\n\nVersion 1.1.0:\n* Support for configurable connection timeout\n\nVersion 1.0.0:\n* Initial version\n* Persistent connections have hardcoded timeout\n```","ref":"changelog.html#old-style-change-log-below"},{"type":"extras","title":"License","doc":"Copyright (c) 2009, Erlang Training and Consulting Ltd.\nAll rights reserved.\n\nRedistribution and use in source and binary forms, with or without\nmodification, are permitted provided that the following conditions are met:\n   * Redistributions of source code must retain the above copyright\n     notice, this list of conditions and the following disclaimer.\n   * Redistributions in binary form must reproduce the above copyright\n     notice, this list of conditions and the following disclaimer in the\n     documentation and/or other materials provided with the distribution.\n   * Neither the name of Erlang Training and Consulting Ltd. nor the\n     names of its contributors may be used to endorse or promote products\n     derived from this software without specific prior written permission.\n\nTHIS SOFTWARE IS PROVIDED BY Erlang Training and Consulting Ltd. ''AS IS''\nAND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE\nIMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE\nARE DISCLAIMED. IN NO EVENT SHALL Erlang Training and Consulting Ltd. BE\nLIABLE SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR\nBUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,\nWHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR\nOTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF\nADVISED OF THE POSSIBILITY OF SUCH DAMAGE.","ref":"license.html"}],"content_type":"text/plain","producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}